#!/bin/sh

if [ -e /media/extern/not_connected ]; then

echo " V E R B I N D U N G S F E H L E R ! ! !"
echo ""
echo " >>> Auf dem Computer <<<" 
echo " Einen neuen Ordner mit Namen {extern} erstellen."
echo " Als Netzwerkfreigabe {extern} mit Schreibrechten freigeben."
echo "" 
echo " >>> Auf der Drembox <<<"
echo " (Menu)>Einstellungen>System-Einstellungen>Externe Volumen"
echo ""
echo " Host/IP: [ {die Netzwerk-IP ihres Computer} ]  Dir: [extern]"
echo " LocalDir: [/media/extern]  Optionen: [r]  Extra: [ {leer lassen} ]"
echo " User [ {Ihr Computer Benutzername eintragen} ]"
echo " Passwort: [ {nur wenn noetig sonst leer lassen} ]"
echo " [v] Auto einhaengen    [(o)einhaengen]"
echo ""
echo " > Weiter mit der (EXIT) - Taste."

else
echo " D R E A M B O X  B A C K U P "
echo ""
echo " Startzeit :" $(date +%Hh' '%Mm' '%Ss)
echo ""

#DIRECTORY=$1
DIRECTORY=/media/extern

touch $DIRECTORY/"~ Backup Script gestartet. ~"
touch $DIRECTORY/"~ Bitte haben Sie etwas geduld. ~"
touch $DIRECTORY/"~ Script endet ca. nach 5 Minuten. ~"


if grep -qs 7020 /proc/bus/dreambox ; then
	BOXTYPE=dm7020
	SND=secondstage-dm7020-35.bin
	OPTIONS="--eraseblock=0x4000 -n -b"
elif grep -qs 600PVR /proc/bus/dreambox ; then
	BOXTYPE=dm600pvr
	SND=secondstage-dm600pvr-51.bin
	OPTIONS="--eraseblock=0x4000 -n -b"
else 
	BOXTYPE=dm7025
	SND=secondstage-dm7025-51.bin
	OPTIONS="--eraseblock=0x4000 -n -l"
fi

echo $BOXTYPE " gefunden!"
echo ""

DATE=`date +%Y%m%d`
MKFS=/usr/bin/mkfs.jffs2
BUILDIMAGE=/usr/bin/buildimage
BACKUPIMAGE=$DIRECTORY/backup_image_$BOXTYPE$DATE.nfi

if [ ! -f $MKFS ] ; then
	echo $MKFS " nicht gefunden!"
	exit 0
fi
if [ ! -f $BUILDIMAGE ] ; then
	echo $BUILDIMAGE " nicht gefunden!"
	exit 0
fi

rm -rf $DIRECTORY/bi
mkdir -p $DIRECTORY/bi
mkdir -p /tmp/bi/root
mkdir -p /tmp/bi/boot

mount -t jffs2 /dev/mtdblock/3 /tmp/bi/root
mount -t jffs2 /dev/mtdblock/2 /tmp/bi/boot

if [ -f /usr/bin/$SND ] ; then
echo "kein Internet notwendig ;o)"
echo "benutze /usr/bin/" $SND
cp /usr/bin/$SND tmp/secondstage.bin
else
echo $SND
echo "heruntergeladen und nach /usr/bin kopiert ;o)"
wget -q http://sources.dreamboxupdate.com/download/7020/$SND -O /tmp/secondstage.bin > /dev/null
chmod 755 /tmp/secondstage.bin 
cp /tmp/secondstage.bin /usr/bin/$SND
fi
	
if [ -f /tmp/secondstage.bin ] ; then
	echo "erstelle boot.jffs2"
	$MKFS --root=/tmp/bi/boot --faketime --output=$DIRECTORY/bi/boot.jffs2 $OPTIONS
	echo "erstelle root.jffs2"
	$MKFS --root=/tmp/bi/root --faketime --output=$DIRECTORY/bi/root.jffs2 $OPTIONS
	echo "erstelle secondstage"
	gzip -c /tmp/secondstage.bin > $DIRECTORY/bi/main.bin.gz
	rm /tmp/secondstage.bin
	
	if [ $BOXTYPE = "dm7025" ] ; then
		echo "erstelle 7025 nfi-image"
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm7020" ] ; then
		echo "erstelle 7020 nfi-image"
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm600pvr" ] ; then
		echo "erstelle 600pvr nfi-image"
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
	fi

	if [ -f $BACKUPIMAGE ] ; then
		echo "nfi-image erstellt nach: " $BACKUPIMAGE
	fi
fi

umount /tmp/bi/root
umount /tmp/bi/boot
rm -rf /tmp/bi
rm -rf $DIRECTORY/bi
rm -rf $DIRECTORY/"~"*
echo""
echo " Endzeit:  " $(date +%Hh' ':%Mm' ':%Ss) "    > Weiter mit der (EXIT) - Taste."
echo""

fi

exit

# finish by treehe